---
title: "Director of Technology at Equality Initiative"
summary: "3 years helping a non-profit manage all technical aspects, from website to email."
author: "Abdullah Tarawneh"
date: "2014-02-20"
start: "Feb 2014"
end: "Feb 2017"
at: "Equality Initiative"
position: "Director of Technology"
tags: ["nonprofit"]
category: "Work"
cover: "/images/cover/eqin.jpg"
---

## Building and maintaining a website

The information architecture was straightforward -- Equality Initiative was split into two activities: funding teachers to go directly to rural students, and incubating social initiatives.

The decided structure was to have an about page describing Equality Initiative, its activities, and its pitch. This would be followed by a page detailing our education activities, and a category of pages for initiatives.

The website was implemented with Wordpress and Divi, to allow ease of editing by anyone in the future if necessary.

When it came time to add a donation flow to the website, I compared several different Wordpress plugins. I eventually decided on Give. 

An archived version is available at https://sites.trwnh.com/equalityinitiative.org for perusal.

## Administrating a managed-hosting email server

Since we were using Bluehost, managing email accounts and quotas was simple.

Inboxes were created for each team member, as well as some utility inboxes for contact and press.

As new team members joined, I would create an inbox for them and set an appropriate quota.