---
title: "Pixelfed team member"
summary: "After making a masterpost of bugs and issues, I turned Pixelfed from a one-person project into a team effort."
author: "Abdullah Tarawneh"
date: "2019-01-06"
start: "Jan 2019"
end: "current"
at: "Pixelfed"
position: "Product/Project Manager"
tags: ["pixelfed", "project management", "product management", "github issues", "documentation"]
category: "Work"
cover: "/images/cover/pixelfed.jpg"
---

## Overview

## Being invited to the team

In June 2018, I made a [masterpost issue](https://github.com/pixelfed/pixelfed/issues/73) including every bug and missing feature from the initial beta release, with a big checklist and organized into areas of interest.

{{< img src="masterpost.jpg" alt="Masterpost of missing functionality and issues from the beta launch" >}}

Additionally, I reported many bugs and contributed some fixes for some months.

dansup decided to invite me to join the Pixelfed organization on Github on January 6, 2019.

## Responsibilities

### Issue triage

I implemented the current issue tagging system.

Issues are assigned tags by the domain they inhabit, a Milestone by rough version target, and a Project by which feature they pertain to. 

### Design consultancy

dansup does a lot of experimenting with building out mock features, and I'm there to tell him which ones are good ideas and which ones are bad ideas.

> i don't trust anyone as much as you to shape the direction of the project.
>
> -- dansup, Pixelfed developer

### Release planning

0.x betas each usually focus on one feature and related development around it. When the focus changes, a new 0.x beta will be tagged. We have a few more betas left, for circles, and for polish. If it weren't for me, dansup would have tagged 1.0 already and media attention would have been lackluster.